'CXmlLM.lib, v2.07, Copyright 2007-2011 T. L. McCaughn All Rights Reserved"
Type XML_ATTRIB
   iString surroundChar[2]			:'the surrounding character
   pointer ptrName          		:'string that names the attribute
   pointer ptrValue         		:'string of data for the attribute
   pointer ptrNext      			:'pointer to the next attribute - 0 if no more
End Type

Type XML_NODE
   def nodeType as int          	:'this is @XML_NODE_TAG,@XML_NODE_XML,
											:'@XML_NODE_DTD,@XML_NODE_COMMENT
   def nodeLevel as int          :'how deep is this? (0 based)
   def ptrEndTag as pointer      :'this is the endtag name
   def ptrTag as pointer         :'this is the tag name 
   def ptrComment as pointer     :'this is the comment or data
	def datType as int				:'0= plain 1=CDATA
   def ptrAttrib as pointer    	:'a pointer to a linked list of XML_ATTRIB_TYPE
   def ptrNext as pointer 			:'pointer to the next node (XML_NODE)
   def ptrPrev as pointer 			:'pointer to the prev node (XML_NODE)
End Type

	'declare __LINE__()

const XML_NODE_TAG     	=  0		:'<name...>, <name.../>, or </name>
const XML_NODE_COMMENT 	=  1		:'<!--text-->
const XML_NODE_XML     	=  2     :'<?name...?>		info not used
const XML_NODE_DTD   	=  3     :'<!text>			info not used

class CXmlLM
	declare _CXmlLM()
	declare CXmlLM()
public
	'member functions
	declare FindRoot(),int
	declare FindFirstChild(tagName As String, opt attribName as string,opt attribValue as string),int
	declare FindLastChild(tagName As String, opt attribName as string,opt attribValue as string),int
	declare FindParent(),int
	declare FindNextPeer(tagName As String, opt attribName as string,opt attribValue as string),int
	declare FindPrevPeer(tagName As String, opt attribName as string,opt attribValue as string),int

	declare AddChildNode(tagName As String, opt attribName as string, opt attribValue as string),int
	declare AddChildNodewData(tagName As String, dat as string, opt typ = 0 as int),int
	declare AddPeerNode(tagName As String, opt attribName as string, opt attribValue as string),int
	declare AddPeerNodewData(tagName As String, dat as string, opt typ = 0 as int),int
	declare AddComment(comment as string),int
	declare DelComment(),int

	declare DelNode(),int
	declare DelAttr(attribName as string),int
	declare DelAllAttr(),int
	declare PutDat(dat as string, opt typ = 0 as int),int
	declare PutAtt(attribName as string,attribValue as string),int

	declare FileLoad(filename as string),int
	declare FileSave(filename as string),int
	declare FileNew(rootName As String),int
	declare FreeNodeMem()
	declare ErrMsg(opt lineno = 0 as int,opt linenumber = __LINE__ as int)
	declare GetDat(buff as string, Datatyp as int byref),int
	declare GetAtt(attribName as String ByVal, opt node as pointer ),String

	declare PrintLM(opt str1 as STRING,...)

private
	declare ParserLevel(Tag as string,Dat as string,EndTag as string, nodetype as int,opt DatType = 0 as int)
	declare FileAddNode(Tag as string,Dat as string,EndTag as string, nodetype as int,opt DatType = 0 as int)
	declare FileAddAttr(aname as string, avalue as string)
	declare CkNode(cnode as pointer),int
	declare AToStr(rootNode2 as pointer),String
	declare FreeAttMem(attribNode as pointer)
	'member variables
public
	int mi_ErrCode
	int mi_Level
	pointer cur_index
	pointer mp_rootAtt
	pointer mp_curAtt
	pointer mp_lastAtt
	pointer mp_rootNode
	pointer mp_curFileNode
	pointer mp_lastNode
	pointer mp_nextNode
	pointer mp_prevNode
	pointer mp_curRootNode
end class



